#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "IB053_test.h"

void prohod(data_struct ** data, int index1, int index2) {
    data_struct * prehoz;
    prehoz = data[index1];
    data[index1] =  data[index2];
    data[index2] = prehoz;
}

int main(int argc, char** argv) {

    int i, j;
    int serazeno;
    clock_t zacatek = clock();
    long pocetPorovnani = 0;
    long pocetProhozeni = 0;

    // vytvorime v pameti pole struktur
    data_struct ** data = malloc (sizeof(data_struct*) * VELIKOST_POLE);
    for (i = 0; i < VELIKOST_POLE; i++) {
        data[i] = malloc(sizeof(data_struct));
    }

    for (j = 0; j < POCET_OPAKOVANI; j++) {

        // naplnime nejakymi daty
        data[0]->realne_cislo = 5.154; 
        for (i = 1; i < VELIKOST_POLE; i++) {
            double r = data[i - 1]->realne_cislo * 10.0;
    	    r = (r - (int)r) * 7 + 2.0 + (i % 10)/10.0;
            r = log10(r);
            r = r * 10000.0;
            r = floor(r);
            data[i]->realne_cislo = r / 1000.0;
        }
        // prevedeme na retezec a na cele cislo
        for (i = 0; i < VELIKOST_POLE; i++) {
            sprintf(data[i]->retezec, "X%1.3lf", data[i]->realne_cislo);
            //printf("%d - %s\n", i, data[i]->retezec);
        }
        // seradime podle retezcu
        serazeno = 0;
        clock_t zacatekCyklu = clock();
        pocetPorovnani = 0;
        pocetProhozeni = 0;
        while (!serazeno) {
            serazeno = 1;
            for (i = 1; i < VELIKOST_POLE; i++) {
                pocetPorovnani++;
    //            if (strcmp(data[i - 1]->retezec, data[i]->retezec) > 0) {
                if (data[i - 1]->realne_cislo > data[i]->realne_cislo) {
                    pocetProhozeni++;
                    prohod(data, i, i - 1);
                    serazeno = 0;
                    break;
                }
            }
        }

    }
    
    clock_t konec = clock();
    printf("Test 2 Jsem hotov, trvalo mi to %f s, pocet porovnani/prohozeni %ld/%ld \n", (konec - zacatek)/1000.0f, pocetPorovnani, pocetProhozeni);
    //printf("Cyklus trval %f s\n", (konec - zacatekCyklu)/1000.0f);
    return (EXIT_SUCCESS);
}

